Subject: Re: bug#18336: 24.4.50; When editing externally changed file, Emacs asks too many questions

From: David Kastrup <[email-masked]>
Date: Thu, 05 Mar 2020 16:07:11 +0100

Noam Postavsky <[email-masked]> writes:

> Eli Zaretskii <[email-masked]> writes:
>
>>> > and my /tmp file system where I also saw this is
>
>>> I ran my initial experiment in ~/tmp,[...]
>>> When I do the same on /tmp, which is mounted noatime I see the extra
>>> "<file> changed on disk; really edit the buffer?" question on C-x C-s.
>
>> lock_file calls verify-visited-file-modtime, which might be affected
>> by the noatime option.  But I don't understand how noatime could
>> affect verify-visited-file-modtime since the latter looks at mtime,
>> not atime.
>
>> Can someone who sees this step with GDB through lock_file and its
>> callees, and see what goes wrong there and why?
>
> Ah, looks like the noatime thing is just a coincidence.  What happens in
> the ~/tmp case is that when lock_file is called from write_region, the
> file doesn't exist, so the extra "changed on disk" question doesn't get
> asked.  The reason the file doesn't exist, is because it was moved to
> the backup name, in backup-buffer.  Files under /tmp/ are not backed up
> by default, so in that case the file still exists and there is an extra
> query.

Sorry for the red herring.  It was the thing that occured to me first.

-- 
David Kastrup